//----------------------------------------------------------------------------
#ifndef App_ProgressDialogH
#define App_ProgressDialogH
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class TAppProgressDialog;
//---------------------------------------------------------------------------
namespace App_progressdialog {
//---------------------------------------------------------------------------
class TAppProgressValues : public TObject
{
private:
	TAppProgressDialog* FOwner;
	AnsiString __fastcall GetProgram();
	void __fastcall SetProgram(const AnsiString& AProgram);
	AnsiString __fastcall GetDocument();
	void __fastcall SetDocument(const AnsiString& ADocument);
	AnsiString __fastcall GetStatus();
	void __fastcall SetStatus(const AnsiString& AStatus);
	int __fastcall GetCurrent();
	void __fastcall SetCurrent(int ACurrent);
	int __fastcall GetAll();
	void __fastcall SetAll(int AAll);
protected:
public:
	__fastcall TAppProgressValues(TAppProgressDialog* AOwner);
	virtual __fastcall ~TAppProgressValues();
	virtual void __fastcall Reset();
	__property TAppProgressDialog* Owner = {read=FOwner};
	__property AnsiString Program = {read=GetProgram, write=SetProgram};
	__property AnsiString Document = {read=GetDocument, write=SetDocument};
	__property AnsiString Status = {read=GetStatus, write=SetStatus};
	__property int Current = {read=GetCurrent, write=SetCurrent};
	__property int All = {read=GetAll, write=SetAll};
};
//---------------------------------------------------------------------------
} // End namespace App_progressdialog
using namespace App_progressdialog;
//---------------------------------------------------------------------------
class TAppProgressDialog : public TForm
{
__published:
	TButton* Button1;
	TLabel* Label1;
	TLabel* Label2;
	TLabel* Label3;
	TLabel* Label4;
	TLabel* Label5;
	TProgressBar* ProgressBar1;
private:
	static const UINT WM_APP_EXECUTE = WM_APP + 0;
	TAppProgressValues* FValues;
	TNotifyEvent FOnExecute;
	TNotifyEvent FOnCancel;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall WMAppExecute(TMessage& AMessage);
protected:
	virtual void __fastcall DoExecute();
	virtual void __fastcall DoCancel();
public:
	__fastcall TAppProgressDialog(TComponent* AOwner);
	virtual __fastcall ~TAppProgressDialog();
	static TAppProgressDialog* __fastcall EnsureCreated();
	virtual bool __fastcall CloseQuery();
	virtual void __fastcall Execute();
	virtual void __fastcall Cancel();
	virtual void __fastcall Finish();
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_APP_EXECUTE, TMessage, WMAppExecute);
	END_MESSAGE_MAP(TForm);
	__property TAppProgressValues* Values = {read=FValues};
	__property TNotifyEvent OnExecute = {read=FOnExecute, write=FOnExecute};
	__property TNotifyEvent OnCancel = {read=FOnCancel, write=FOnCancel};
};
//----------------------------------------------------------------------------
extern PACKAGE TAppProgressDialog* AppProgressDialog;
//----------------------------------------------------------------------------
#endif

