//---------------------------------------------------------------------------
#ifndef App_SettingsH
#define App_SettingsH
//---------------------------------------------------------------------------
#include "App_Commands.h"
//---------------------------------------------------------------------------
namespace App_settings {
//---------------------------------------------------------------------------
class ESettingsError : public Exception
{
public:
	__fastcall ESettingsError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TSettingsModel : public TObject
{
private:
	static const AnsiString SettingsFile;
	TStrings* FSections;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	__property TStrings* Sections = {read=FSections};
protected:
public:
	__fastcall TSettingsModel();
	virtual __fastcall ~TSettingsModel();
	virtual void __fastcall Load();
	virtual void __fastcall Save();
	virtual void __fastcall Register(const AnsiString& ASection, TCommands* ACommands);
	virtual void __fastcall Unregister(const AnsiString& ASection);
};
//---------------------------------------------------------------------------
class TSettingsCommands : public TCommands
{
private:
	TSettingsModel* FSettingsModel;
	__property TSettingsModel* SettingsModel = {read=FSettingsModel};
protected:
public:
	__fastcall TSettingsCommands(TSettingsModel* ASettingsModel);
	virtual __fastcall ~TSettingsCommands();
	virtual void __fastcall Load();
	virtual bool __fastcall CanLoad();
	virtual void __fastcall Save();
	virtual bool __fastcall CanSave();
	virtual void __fastcall LoadSettings(TMemIniFile* AValues, const AnsiString& ASection);
	virtual void __fastcall SaveSettings(TMemIniFile* AValues, const AnsiString& ASection);
};
//---------------------------------------------------------------------------
} // End namespace App_settings
using namespace App_settings;
//---------------------------------------------------------------------------
#endif

