//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <IniFiles.hpp>
#include "App_View.h"
#include "Moa_Forms.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_view {
//---------------------------------------------------------------------------
__fastcall TViewModel::TViewModel(TForm* AMainForm, TListView* AListView) :
	TObject(),
	FMainForm(AMainForm),
	FListView(AListView)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TViewModel::~TViewModel()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TViewCommands::TViewCommands(TViewModel* AViewModel) :
	TCommands(),
	FViewModel(AViewModel)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TViewCommands::~TViewCommands()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TViewCommands::LoadSettings(TMemIniFile* AValues, const AnsiString& ASection)
{
	AnsiString LSection = ASection + ".MainForm";
	{
		TRect LBounds = TFormUtilities::GetNormalBounds(ViewModel->MainForm);
		LBounds.left = AValues->ReadInteger(LSection, "Left", LBounds.left);
		LBounds.top = AValues->ReadInteger(LSection, "Top", LBounds.top);
		LBounds.right = AValues->ReadInteger(LSection, "Right", LBounds.right);
		LBounds.bottom = AValues->ReadInteger(LSection, "Bottom", LBounds.bottom);
		TFormUtilities::SetNormalBounds(ViewModel->MainForm, LBounds);
	}
	LSection = ASection + ".ListView.Columns";
	{
		for(int LI = 0; LI < ViewModel->ListView->Columns->Count; ++LI) {
			ViewModel->ListView->Columns->Items[LI]->Width = AValues->ReadInteger(
				LSection + ".Items[" + LI + "]",
				"Width",
				ViewModel->ListView->Columns->Items[LI]->Width);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TViewCommands::SaveSettings(TMemIniFile* AValues, const AnsiString& ASection)
{
	AnsiString LSection = ASection + ".MainForm";
	{
		TRect LBounds = TFormUtilities::GetNormalBounds(ViewModel->MainForm);
		AValues->WriteInteger(LSection, "Left", LBounds.left);
		AValues->WriteInteger(LSection, "Top", LBounds.top);
		AValues->WriteInteger(LSection, "Right", LBounds.right);
		AValues->WriteInteger(LSection, "Bottom", LBounds.bottom);
	}
	LSection = ASection + ".ListView.Columns";
	{
		for(int LI = 0; LI < ViewModel->ListView->Columns->Count; ++LI) {
			AValues->WriteInteger(
				LSection + ".Items[" + LI + "]",
				"Width",
				ViewModel->ListView->Columns->Items[LI]->Width);
		}
	}
}
//---------------------------------------------------------------------------
} // End namespace App_view
//---------------------------------------------------------------------------

