//---------------------------------------------------------------------------
#ifndef App_ViewH
#define App_ViewH
//---------------------------------------------------------------------------
#include "App_Commands.h"
#include <ComCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
namespace App_view {
//---------------------------------------------------------------------------
class EViewError : public Exception
{
public:
	__fastcall EViewError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TViewModel : public TObject
{
private:
	TForm* FMainForm;
	TListView* FListView;
protected:
public:
	__fastcall TViewModel(TForm* AMainForm, TListView* AListView);
	virtual __fastcall ~TViewModel();
	__property TForm* MainForm = {read=FMainForm};
	__property TListView* ListView = {read=FListView};
};
//---------------------------------------------------------------------------
class TViewCommands : public TCommands
{
private:
	TViewModel* FViewModel;
	__property TViewModel* ViewModel = {read=FViewModel};
protected:
public:
	__fastcall TViewCommands(TViewModel* AViewModel);
	virtual __fastcall ~TViewCommands();
	virtual void __fastcall LoadSettings(TMemIniFile* AValues, const AnsiString& ASection);
	virtual void __fastcall SaveSettings(TMemIniFile* AValues, const AnsiString& ASection);
};
//---------------------------------------------------------------------------
} // End namespace App_view
using namespace App_view;
//---------------------------------------------------------------------------
#endif

