//---------------------------------------------------------------------------
#ifndef Moa_ClipboardH
#define Moa_ClipboardH
//---------------------------------------------------------------------------
// Version: 1.0.1
// Date: 2012-03-01 UTC+09:00
// Version: 1.0.0
// Date: 2011-08-13 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_windows { class TMessageWindow; } using namespace Moa_windows;
//---------------------------------------------------------------------------
namespace Moa_clipboard {
//---------------------------------------------------------------------------
class EClipboardError : public Exception
{
public:
	__fastcall EClipboardError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TClipboardWatcher : public TObject
{
private:
	HWND FViewer;
	HWND FNextViewer;
	TNotifyEvent FOnChange;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall Attach();
	void __fastcall Detach();
	void __fastcall HandleMessage(TMessage& AMessage);
	void __fastcall WMDrawClipboard(TMessage& AMessage);
	void __fastcall WMChangeCbChain(TMessage& AMessage);
	bool __fastcall GetEnabled();
	void __fastcall SetEnabled(bool AEnabled);
	__property HWND Viewer = {read=FViewer};
	__property HWND NextViewer = {read=FNextViewer};
protected:
	virtual void __fastcall DoChange();
public:
	__fastcall TClipboardWatcher();
	virtual __fastcall ~TClipboardWatcher();
	__property bool Enabled = {read=GetEnabled, write=SetEnabled};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
} // End namespace Moa_clipboard
using namespace Moa_clipboard;
//---------------------------------------------------------------------------
#endif

