//---------------------------------------------------------------------------
#ifndef Moa_FormsH
#define Moa_FormsH
//---------------------------------------------------------------------------
// Version: 1.0+1.0
// Date: 2012-04-03 UTC+09:00
// Version: 1.0.0
// Date: 2011-12-13 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_forms {
//---------------------------------------------------------------------------
class TUpdateNotifier : public TObject
{
private:
	static const UINT WM_APP_UPDATE = WM_APP + 0;
	HWND FWindow;
	bool FInvalidated;
	TNotifyEvent FOnUpdate;
	static void __fastcall RemoveMessage(HWND AWindow, UINT AMessageType);
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall HandleMessage(TMessage& AMessage);
	__property HWND Window = {read=FWindow};
protected:
	virtual void __fastcall DoUpdate();
public:
	__fastcall TUpdateNotifier();
	virtual __fastcall ~TUpdateNotifier();
	virtual void __fastcall Invalidate();
	virtual void __fastcall Update();
	virtual void __fastcall Refresh();
	__property bool Invalidated = {read=FInvalidated};
	__property TNotifyEvent OnUpdate = {read=FOnUpdate, write=FOnUpdate};
};
//---------------------------------------------------------------------------
class TFormUtilities
{
private:
protected:
public:
	static TRect __fastcall GetNormalBounds(TForm* AForm);
	static void __fastcall SetNormalBounds(TForm* AForm, const TRect& ABounds);
	static TPoint __fastcall GetNormalPosition(TForm* AForm);
	static void __fastcall SetNormalPosition(TForm* AForm, const TPoint& APosition);
	static WINDOWPLACEMENT __fastcall GetPlacement(TForm* AForm);
	static void __fastcall SetPlacement(TForm* AForm, const WINDOWPLACEMENT& APlacement);
};
//---------------------------------------------------------------------------
} // End namespace Moa_forms
using namespace Moa_forms;
//---------------------------------------------------------------------------
#endif

